#ifndef RI_PORTS_H
#define RI_PORTS_H

#include "stdint.h"


typedef enum {
	RI_PIN_TIAGAIN,
	RI_PIN_AAFILTER,
	RI_PIN_POWEROFF,
	RI_PIN_ADCCLOCK,
	RI_PIN_CURRENTMONITOR,

	RI_PIN_SCLK,
	RI_PIN_SDIO,
	RI_PIN_CSB,

	RI_NPINS,
} RI_PIN_t;
#define RI_NCONFIGPINS 5

typedef enum {
	RI_PIN_MODE_IN,
	RI_PIN_MODE_OUT,
	// pin reserved for software serial communication
	RI_PIN_MODE_SERIAL,
	// pin not enabled for this board
	RI_PIN_MODE_UNUSED,
} RI_PIN_MODE_t;


typedef struct {
	uint8_t pin;
	uint8_t value;
	uint8_t mode;
} RI_PINCONFIG_t;


typedef enum {
	RI_PORT_A,
	RI_PORT_B,
	RI_PORT_S,
	RI_PORT_T,

	RI_PORT_LEDR,
	RI_PORT_LEDG,
	RI_PORT_LEDB,
	RI_NPORTS,
} RI_PORT_t;


typedef enum {
	RI_PORT_MODE_DIGITAL_IN,
	RI_PORT_MODE_DIGITAL_OUT,
	RI_PORT_MODE_STREAM_IN,
	RI_PORT_MODE_ANALOG_OUT,
	RI_PORT_MODE_PWM,
	RI_PORT_MODE_PULSE,
} RI_PORT_MODE_t;


#pragma pack(push)  /* push current alignment to stack */
#pragma pack(1)     /* set alignment to 1 byte boundary */

typedef struct {
	uint8_t mode;
	uint8_t value;
	uint32_t period;
	uint32_t threshold;
} RI_PORTCONFIG_t;

#pragma pack(pop)
#endif // RI_PORTS_H
